# =========================================================
# TestEncoder01.py: Manual one hot encoding with numpy
# =========================================================

from numpy import argmax

print("=====================================================")
print("TestEncoder01.py ... ")
print("=====================================================")

# define input string

data = 'hello world'
print("--- Input string: %s" %(data))

# define universe of possible input values

alphabet = 'abcdefghijklmnopqrstuvwxyz '
print("--- Alphabet of input values: %s" %(alphabet))

# define a mapping of chars to integers

char_to_int = dict((c, i) for i, c in enumerate(alphabet))
int_to_char = dict((i, c) for i, c in enumerate(alphabet))

# integer encode input data

integer_encoded = [char_to_int[char] for char in data]
print("--- Integer encoded input data: %s" %(integer_encoded))

# one hot encode

print("--- One hot encode ...")

onehot_encoded = list()
for value in integer_encoded:
	letter = [0 for _ in range(len(alphabet))]
	letter[value] = 1
	onehot_encoded.append(letter)
print(onehot_encoded)

# invert encoding

print("--- Invert encoding ...")

print("--- Encoding[ 0] : %s" %( int_to_char[argmax(onehot_encoded[0])] ))
print("--- Encoding[ 1] : %s" %( int_to_char[argmax(onehot_encoded[1])] ))
print("--- Encoding[ 2] : %s" %( int_to_char[argmax(onehot_encoded[2])] ))
print("--- Encoding[ 3] : %s" %( int_to_char[argmax(onehot_encoded[3])] ))
print("--- Encoding[ 4] : %s" %( int_to_char[argmax(onehot_encoded[4])] ))
print("--- Encoding[ 5] : %s" %( int_to_char[argmax(onehot_encoded[5])] ))
print("--- Encoding[ 6] : %s" %( int_to_char[argmax(onehot_encoded[6])] ))
print("--- Encoding[ 7] : %s" %( int_to_char[argmax(onehot_encoded[7])] ))
print("--- Encoding[ 8] : %s" %( int_to_char[argmax(onehot_encoded[8])] ))
print("--- Encoding[ 9] : %s" %( int_to_char[argmax(onehot_encoded[9])] ))
print("--- Encoding[10] : %s" %( int_to_char[argmax(onehot_encoded[10])] ))

print("=====================================================")
print("Finished !! ")
