# ===============================================================
# TestGraph.py: Exercise simple graph data structure ...
# ===============================================================

import pprint
from Graph import Graph

# main method ...

def main():
    print("--- Enter TestGraph.main()     ... ");
    print("--- ======================================== ... ");

    # Create list of connections ...

    connections = [('A', 'B'), ('B', 'C'), ('B', 'D'), ('C', 'D'),
                   ('E', 'F'), ('F', 'C')]

    # Part 1: Create directed graph ...

    print("--- Part 1: Create directed graph ... ");

    g = Graph(connections, directed=True)

    # Print graph ...

    pretty_print = pprint.PrettyPrinter()
    pretty_print.pprint(g._graph)

    # Part 2: Create undirected graph ...

    print("--- Part 2: Create undirected graph ... ");

    g = Graph(connections)  # undirected
    pretty_print = pprint.PrettyPrinter()
    pretty_print.pprint(g._graph)

    # Part 3: Add edge (E,D) ...

    print("--- Part 3: Add edge (E,D) ... ");

    g.add('E', 'D')
    pretty_print.pprint(g._graph)

    # Part 4: Remove node "A" ...

    print("--- Part 4: Remove node \"A\" ... ");

    g.remove('A')
    pretty_print.pprint(g._graph)

    print("--- ======================================== ... ");
    print("--- Leave TestGraph.main()     ... ");

# call the main method ...

main()
