# =========================================================
# ColoredCircle.py: Extend circle to create coloredcircles.
# 
# Written by: Mark Austin                     October, 2022 
# =========================================================

from Circle import Circle

class ColoredCircle(Circle):
  def __init__(self, x, y, radius, color):
    Circle.__init__(self, x, y, radius)
    self._color = color

  def printColoredCircle(self):
    print("--- ColoredCircle:", self.color)

  # Set/get color ...

  def setColor(self, color):
    self._color = color

  def getColor(self):
    return self._color

  # String representation of colored circle ...

  def __str__(self):
    return "--- ColoredCircle: (x,y) = (%4.1f, %4.1f): radius = %5.2f: area = %6.2f: color = %s" % (
            self._x, self._y, self._radius, self._area, self._color )

