# ===============================================================
# TestMatrixEquations01.py: Solution of matrix equations ...
# 
#                                                   November 2022 
# ===============================================================

import numpy as np               # Make numpy available using np.
from numpy.linalg import matrix_rank

# ===============================================================
# Function to print two-dimensional matrices ...
# ===============================================================

def PrintMatrix(name, a):
    print("Matrix: {:s} ".format(name) );
    for row in a:
        for col in row:
            print("{:8.3f}".format(col), end=" ")
        print("")

# ===============================================================
# main method ...
# ===============================================================

def main():
    print("--- Enter TestMatrixEquations01.main()      ... ");
    print("--- ======================================== ... ");

    print("--- ");
    print("--- Part 1: Create test matrices ... ");
    print("--- ");

    A = np.array([ [2, 0,  0], [3,-1,  6], [4, 6, -2] ]);
    PrintMatrix("A", A);

    B = np.array([ [2], [3], [10] ]);
    PrintMatrix("B", B);

    print("--- ");
    print("--- Part 2: Check properties of matrix A ... ");
    print("--- ");

    rank = matrix_rank(A)
    det  = np.linalg.det(A)

    print("--- Matrix A: rank = {:f}, det = {:f}  ...".format(rank, det) );

    print("--- ");
    print("--- Part 3: Solve A.x = B ... ");
    print("--- ");

    x = np.linalg.solve(A, B)
    PrintMatrix("x", x);

    print("--- ======================================== ... ");
    print("--- Leave TestMatrixEquations01.main()      ... ");

# call the main method ...

main()
